#!/usr/bin/perl -w
# A script to pick up the cDNA record from cDNA database according to the pep record.
#    perl cDNApicker.pl pep.fas cDNA.fas

use strict;
use warnings;

my $keyWordBeforeCDNAid = "transcript:";    ### Pick up the cDNA id form pep file name line.
my $cDNAid = "";

my $PEPdb  = $ARGV[0];
my $cDNAdb = $ARGV[1];
my $outNucFile = "Out_".$cDNAdb;
my $countCDNAprint = 0;


### Push the pep records into the hash and array
open(AASEQ,"$PEPdb") or die"$!";
my @aaSeqFile = <AASEQ>;
close AASEQ;
my ($ref_fasHashAA,$ref_nameArrayAA) = &fasHashReader(\@aaSeqFile);
@aaSeqFile = "";


### Push the cDNA records into the hash and array
open(DNASEQ,"$cDNAdb") or die"$!";
my @dnaSeqFile = <DNASEQ>;
close DNASEQ;
my ($ref_fasHashDNA,$ref_nameArrayDNA) = &fasHashReader(\@dnaSeqFile);
@dnaSeqFile = "";


##### Main program

open(OUTA,">$outNucFile");
foreach my $aaName (@$ref_nameArrayAA){
  $aaName =~ /transcript:(\w+)$/;                           # Pick up the ENST ID from the name line of AA file
  $cDNAid = $1;
  my @temp = grep(/$cDNAid/,@$ref_nameArrayDNA);
  my $cDNAnameLine = shift(@temp);
#  print "$cDNAid -> $cDNAnameLine\n";
  print OUTA "$cDNAnameLine\n$ref_fasHashDNA->{$cDNAnameLine}\n";
  $countCDNAprint++;
}
close OUTA;

print "  pep : ".@$ref_nameArrayAA." records\n";
print "  cdna : $countCDNAprint found\n";

exit;


##############
sub fasHashReader{

  my $name = "";
  my $seq = "";
  my $flag = 0;
  my @nameArraySR = ( );
  my %fasHashSR = ( );

  my ($inFileContSR) = @_;

  foreach my $inFileLine (@$inFileContSR) {
    chomp($inFileLine);
    if($inFileLine =~ /^>/){  
      if($flag == 0){
        $name = $inFileLine;
        $flag = 1;  
      } else {
        $fasHashSR{$name} = $seq;  
        push(@nameArraySR,$name);
        $name = "$inFileLine";
        $seq  = "";
      }
    } else {
      $seq .= $inFileLine; 
    }
  }
  $fasHashSR{$name} = $seq;
  push(@nameArraySR,$name);
  return (\%fasHashSR,\@nameArraySR);
}


###########
# This subroutine uses "while", so it assumes one records for one ID in the DB.
sub seqRetFromFastaDBwithWhile {

  my ($cDNAid,$dbName) = @_;

  my $flag = 0;
  my $key  = "";                # key of the above hash
  my $seq  = "";                # seq of the above hash
  my %hitRecord = ( );         # Hit record. 

  open(INFILEWH,"$dbName") or die "$!";
  while (my $dbLine = <INFILEWH>) {
    chomp($dbLine);
    if($flag == 1){
      if($dbLine =~ /^>/){
        last;
      } else {
        $seq .= $dbLine;
      }
    }
    if($dbLine =~ /^>/ && $dbLine =~ /$cDNAid/ ){
      $key = $dbLine;
      $flag = 1;
    }
  }
  $hitRecord{$key} = $seq;

  close INFILEWH;
  return \%hitRecord;
}